/*
** minimal SSLProxy server for content switch project
** pieces of code taken from modssl which is protected under the below licence
 *			ganesh kumar godavari (gkgodava@archie.uccs.edu)
*/

/********************* EDITABLE SECTION ********************/
#define CLIENT_TIMEOUT 			30
#define SERVER_ROOT			"/home/gkgodava/rulemodule"
#define LOG_FILE 			"log/ssl.log"
#define SESS_FILE			"cache/scache"
#define SERVER_IP 			 "128.198.60.22"
#define SERVER_NAME			"calvin.uccs.edu"
#define RULE_SERVER_NAME		"calvin.uccs.edu"
#define RULE_SERVER_PORT		4000
#define DEFAULT_RULE_SERVER_NAME	"calvin.uccs.edu"
#define DEFAULT_RULE_SERVER_PORT	4000
#define CA_FILE     			"testssl/CA/cacert.pem"
#define CA_PATH     			"testssl/CA"
#define KEY_FILE    			"testssl/private/private.key"
#define CERT_FILE   			"testssl/cert/newcert.pem"
#define RAND_FILE   			"testssl/random/random.pem" /* random is a junk file that contains any data--ensure it is not repeated*/
#define SSL_SESSION_CACHE_TIMEOUT 	300
#define STICKY_SIZE 			20			    /* allocation for maximum # of the sticky connection */

/*
** it does this by periodically checking how many servers are waiting
** for a request.  If there are fewer than MinSpareServers, it creates
** a new spare.  If there are more than MaxSpareServers, some of the
** spares die off.
**
*/
#define MinSpareServers 2
#define MaxSpareServers 5

/*
** Number of servers to start initially --- should be a reasonable ballpark
** figure.
*/
#define StartServers 5

/*
** Limit on total number of servers running, i.e., limit on the number
** of clients who can simultaneously connect --- if this limit is ever
** reached, clients will be LOCKED OUT, so it should NOT BE SET TOO LOW.
** It is intended mainly as a brake to keep a runaway server from taking
** the system with it as it spirals down...
*/
#define MaxClients 25

/*
** MaxRequestsPerChild: the number of requests each child process is
** allowed to process before the child dies.  The child will exit so
** as to avoid problems after prolonged 
**
** NOTE: This value does not include keepalive requests after the initial
**       request per connection. For example, if a child process handles
**       an initial request and 10 subsequent "keptalive" requests, it
**       would only count as 1 request towards this limit.
*/
#define MaxRequestsPerChild 50

/*
** Listen: Allows you to bind to a specific  Ports
*/
#define SERVER_PORT 		80	

/*
** Prefork header file locks the following file
*/
#define PREFORK_LOCK "/tmp/install.log"


/*
** lock file for critical section handling
*/
#define CRITICAL_LOCK "/dev/zero"



/*****************End of Editable Section************/


/* define constants --------- Non Editable Section */
#define SSL_DBM_FILE_MODE   	(S_IRUSR | S_IWUSR)
#define SSL_MUTEX_LOCK_MODE   	(S_IRUSR | S_IWUSR)
#define IOBUFFSIZE	   	4096

/* End of Non Editable Section */
